Debian Bug report logs - #578547
libdata-alias-perl: FTBFS with Perl 5.12: 'Nullsv' undeclared

version graph

Package: libdata-alias-perl; Maintainer for libdata-alias-perl is Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>; Source for libdata-alias-perl is src:libdata-alias-perl.

Reported by: Niko Tyni <ntyni@debian.org>

Date: Tue, 20 Apr 2010 17:45:01 UTC

Severity: important

Tags: fixed-upstream, help

Found in version libdata-alias-perl/1.07-1

Fixed in version libdata-alias-perl/1.08-1

Done: Ansgar Burchardt <ansgar@debian.org>

Bug is archived. No further changes may be made.

Forwarded to http://rt.cpan.org/Public/Bug/Display.html?id=36165

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#578547; Package libdata-alias-perl. (Tue, 20 Apr 2010 17:45:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Niko Tyni <ntyni@debian.org>:
New Bug report received and forwarded. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Tue, 20 Apr 2010 17:45:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Niko Tyni <ntyni@debian.org>
To: submit@bugs.debian.org
Subject: libdata-alias-perl: FTBFS with Perl 5.12: 'Nullsv' undeclared
Date: Tue, 20 Apr 2010 20:42:45 +0300
Package: libdata-alias-perl
Version: 1.07-1
Severity: important
User: debian-perl@lists.debian.org
Usertags: perl-5.12-transition
Forwarded: http://rt.cpan.org/Public/Bug/Display.html?id=36165

This package fails to build with Perl 5.12.0 (currently in experimental):

 cc -c   -D_REENTRANT -D_GNU_SOURCE -DDEBIAN -fno-strict-aliasing -pipe -fstack-protector -I/usr/local/incl
 ude -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -O2 -g   -DVERSION=\"1.07\" -DXS_VERSION=\"1.07\" -fPIC "-I
 /usr/lib/perl/5.12/CORE"   Alias.c
 Alias.xs: In function 'da_localize_gvar':
 Alias.xs:369: error: 'Nullsv' undeclared (first use in this function)
 Alias.xs:369: error: (Each undeclared identifier is reported only once
 Alias.xs:369: error: for each function it appears in.)
 Alias.xs: In function 'da_refgen':
 Alias.xs:376: error: 'SVt_RV' undeclared (first use in this function)
 Alias.xs: In function 'DataAlias_pp_rv2sv':
 Alias.xs:690: warning: 'PL_no_symref' is deprecated (declared at /usr/lib/perl/5.12/CORE/perl.h:4241)
 Alias.xs: In function 'DataAlias_pp_rv2gv':
 Alias.xs:747: warning: 'PL_no_symref' is deprecated (declared at /usr/lib/perl/5.12/CORE/perl.h:4241)
 Alias.xs: In function 'DataAlias_pp_return':
 Alias.xs:1251: error: 'Nullsv' undeclared (first use in this function)
 Alias.xs: In function 'da_transform':
 Alias.xs:1436: error: 'Nullop' undeclared (first use in this function)
 Alias.xs:1450: error: 'OP_SETSTATE' undeclared (first use in this function)
 Alias.xs: In function 'da_peep2':
 Alias.xs:1589: error: 'OP_SETSTATE' undeclared (first use in this function)
 Alias.xs: In function 'da_ck_entersub':
 Alias.xs:1767: error: 'Nullop' undeclared (first use in this function)
 make[1]: *** [Alias.o] Error 1
 
This is also [rt.cpan.org #36165] with no action since May 2008.
As mentioned in the ticket, the fix may well be quite easy.
-- 
Niko Tyni   ntyni@debian.org




Added tag(s) help. Request was from Damyan Ivanov <dmn@debian.org> to control@bugs.debian.org. (Thu, 22 Apr 2010 15:21:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#578547; Package libdata-alias-perl. (Thu, 22 Apr 2010 15:30:06 GMT) Full text and rfc822 format available.

Message #10 received at 578547@bugs.debian.org (full text, mbox):

From: Damyan Ivanov <dmn@debian.org>
To: Niko Tyni <ntyni@debian.org>, 578547@bugs.debian.org
Subject: Re: Bug#578547: libdata-alias-perl: FTBFS with Perl 5.12: 'Nullsv' undeclared
Date: Thu, 22 Apr 2010 18:15:47 +0300
-=| Niko Tyni, Tue, Apr 20, 2010 at 08:42:45PM +0300 |=-
> Package: libdata-alias-perl
> Version: 1.07-1
> Severity: important
> User: debian-perl@lists.debian.org
> Usertags: perl-5.12-transition
> Forwarded: http://rt.cpan.org/Public/Bug/Display.html?id=36165
> 
> This package fails to build with Perl 5.12.0 (currently in experimental):
> 
>  cc -c   -D_REENTRANT -D_GNU_SOURCE -DDEBIAN -fno-strict-aliasing -pipe -fstack-protector -I/usr/local/incl
>  ude -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -O2 -g   -DVERSION=\"1.07\" -DXS_VERSION=\"1.07\" -fPIC "-I
>  /usr/lib/perl/5.12/CORE"   Alias.c
>  Alias.xs: In function 'da_localize_gvar':
>  Alias.xs:369: error: 'Nullsv' undeclared (first use in this function)
>  Alias.xs:369: error: (Each undeclared identifier is reported only once
>  Alias.xs:369: error: for each function it appears in.)
>  Alias.xs: In function 'da_refgen':
>  Alias.xs:376: error: 'SVt_RV' undeclared (first use in this function)
>  Alias.xs: In function 'DataAlias_pp_rv2sv':
>  Alias.xs:690: warning: 'PL_no_symref' is deprecated (declared at /usr/lib/perl/5.12/CORE/perl.h:4241)
>  Alias.xs: In function 'DataAlias_pp_rv2gv':
>  Alias.xs:747: warning: 'PL_no_symref' is deprecated (declared at /usr/lib/perl/5.12/CORE/perl.h:4241)
>  Alias.xs: In function 'DataAlias_pp_return':
>  Alias.xs:1251: error: 'Nullsv' undeclared (first use in this function)
>  Alias.xs: In function 'da_transform':
>  Alias.xs:1436: error: 'Nullop' undeclared (first use in this function)
>  Alias.xs:1450: error: 'OP_SETSTATE' undeclared (first use in this function)
>  Alias.xs: In function 'da_peep2':
>  Alias.xs:1589: error: 'OP_SETSTATE' undeclared (first use in this function)
>  Alias.xs: In function 'da_ck_entersub':
>  Alias.xs:1767: error: 'Nullop' undeclared (first use in this function)
>  make[1]: *** [Alias.o] Error 1
>  
> This is also [rt.cpan.org #36165] with no action since May 2008.
> As mentioned in the ticket, the fix may well be quite easy.

That ticket only talks about NullXX being replaced with NULL, which 
seems to fix only part of the problem. There are also SVt_RV, 
PL_no_symref and OP_SETSTATE missing.

I tried replacing SVt_RV with SVt_IV, but the tests failed under 
5.10.1. Perhaps I misunderstood perl5120delta.

No idea what to replace the other two with.




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#578547; Package libdata-alias-perl. (Thu, 22 Apr 2010 18:15:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Niko Tyni <ntyni@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Thu, 22 Apr 2010 18:15:03 GMT) Full text and rfc822 format available.

Message #15 received at 578547@bugs.debian.org (full text, mbox):

From: Niko Tyni <ntyni@debian.org>
To: 578547@bugs.debian.org
Subject: Re: Bug#578547: libdata-alias-perl: FTBFS with Perl 5.12: 'Nullsv' undeclared
Date: Thu, 22 Apr 2010 21:12:22 +0300
[Message part 1 (text/plain, inline)]
On Thu, Apr 22, 2010 at 06:15:47PM +0300, Damyan Ivanov wrote:
> -=| Niko Tyni, Tue, Apr 20, 2010 at 08:42:45PM +0300 |=-
> > Package: libdata-alias-perl
> > Version: 1.07-1
> > Severity: important
> > User: debian-perl@lists.debian.org
> > Usertags: perl-5.12-transition
> > Forwarded: http://rt.cpan.org/Public/Bug/Display.html?id=36165
> > 
> > This package fails to build with Perl 5.12.0 (currently in experimental):

> That ticket only talks about NullXX being replaced with NULL, which 
> seems to fix only part of the problem. There are also SVt_RV, 
> PL_no_symref and OP_SETSTATE missing.

I got as far as getting it to compile (patch attached) without breaking
5.10.1, but the tests segfault on 5.12.

SVt_RV can be #define'd to SVt_IV on >= 5.11.0. See
/usr/lib/perl/5.12/CORE/sv.h, which would take care of compatibility if
Alias.xs didn't #define PERL_CORE. (I understand this is very much frowned
upon for CPAN modules.)

OP_SETSTATE was disabled before 5.6.0 AFAICS and finally removed
in the 5.11 series.
 http://perl5.git.perl.org/perl.git/commit/38a230cb455fb1aca316039ba1d4aed58c0c60d5

The set of reverse dependencies is rather big, so this is going to be
something of a blocker.
-- 
Niko Tyni   ntyni@debian.org
[578547-partial.patch (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#578547; Package libdata-alias-perl. (Mon, 26 Apr 2010 19:00:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Niko Tyni <ntyni@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Mon, 26 Apr 2010 19:00:08 GMT) Full text and rfc822 format available.

Message #20 received at 578547@bugs.debian.org (full text, mbox):

From: Niko Tyni <ntyni@debian.org>
To: 578547@bugs.debian.org
Subject: Re: Bug#578547: libdata-alias-perl: FTBFS with Perl 5.12: 'Nullsv' undeclared
Date: Mon, 26 Apr 2010 21:57:30 +0300
On Thu, Apr 22, 2010 at 09:12:22PM +0300, Niko Tyni wrote:
 
> I got as far as getting it to compile (patch attached) without breaking
> 5.10.1, but the tests segfault on 5.12.

I have some good and some bad news.

The bad news is that fixing the segfaults looks far from trivial.
The Perl change that broke this is probably
 http://perl5.git.perl.org/perl.git/commit/f7461760003db2ce68155c97ea6c1658e96fcd27

AIUI, Data::Alias hooks onto OP_RV2CV and modifies the parser state, but
the change makes the rv2cv op get generated earlier and the modifications
break. I doubt I'll be able to put a fix together (but I haven't quite
given up yet.)

The good news is that the only direct reverse dependency,
libdata-visitor-perl, only uses Data::Alias::deref(), which works fine
with 5.12. Furthermore, it's really a soft dependency and the relevant
tests are skipped if Data::Alias is not installed.

This gives us a few new options, assuming libdata-alias-perl doesn't
get fixed in time (or at all):

A: disable the test suite in libdata-alias-perl and ship a package
   that works just 'well enough'

B: remove libdata-alias-perl from the archive: either
  B1. remove the libdata-visitor-perl dependency on libdata-alias-perl
    and hope that no libdata-visitor-perl reverse dependencies need
    the removed functionality
 OR
  B2. split Data::Alias::deref() out into a new package and make
    libdata-visitor-perl use that.
 OR
  B3. find another dereferencing implementation and make
    libdata-visitor-perl use that.

B2 or B3 are the only options that look "right" to me.

Obviously upstream should be involved.
-- 
Niko Tyni   ntyni@debian.org




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#578547; Package libdata-alias-perl. (Wed, 12 May 2010 07:51:13 GMT) Full text and rfc822 format available.

Acknowledgement sent to Niko Tyni <ntyni@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Wed, 12 May 2010 07:51:14 GMT) Full text and rfc822 format available.

Message #25 received at 578547@bugs.debian.org (full text, mbox):

From: Niko Tyni <ntyni@debian.org>
To: 578547@bugs.debian.org
Subject: Re: Bug#578547: libdata-alias-perl: FTBFS with Perl 5.12: 'Nullsv' undeclared
Date: Wed, 12 May 2010 10:49:54 +0300
clone 578547 -1
retitle -1 libdata-visitor-perl: move away from libdata-alias-perl ?
reassign -1 libdata-visitor-perl 0.27-1  
forwarded -1 http://rt.cpan.org/Ticket/Display.html?id=57410
user debian-perl@lists.debian.org
usertags -1 perl-5.12-transition
thanks

On Mon, Apr 26, 2010 at 09:57:30PM +0300, Niko Tyni wrote:

> The good news is that the only direct reverse dependency,
> libdata-visitor-perl, only uses Data::Alias::deref(), which works fine
> with 5.12. Furthermore, it's really a soft dependency and the relevant
> tests are skipped if Data::Alias is not installed.
> 
> This gives us a few new options, assuming libdata-alias-perl doesn't
> get fixed in time (or at all):
> 
> A: disable the test suite in libdata-alias-perl and ship a package
>    that works just 'well enough'
> 
> B: remove libdata-alias-perl from the archive: either
>   B1. remove the libdata-visitor-perl dependency on libdata-alias-perl
>     and hope that no libdata-visitor-perl reverse dependencies need
>     the removed functionality
>  OR
>   B2. split Data::Alias::deref() out into a new package and make
>     libdata-visitor-perl use that.
>  OR
>   B3. find another dereferencing implementation and make
>     libdata-visitor-perl use that.
> 
> B2 or B3 are the only options that look "right" to me.
> 
> Obviously upstream should be involved.

I've filed [rt.cpan.org #57410] on Data-Visitor about this and updated the Data-Alias
ticket [rt.cpan.org #36165].
-- 
Niko Tyni   ntyni@debian.org




Bug 578547 cloned as bug 581268. Request was from Niko Tyni <ntyni@debian.org> to control@bugs.debian.org. (Wed, 12 May 2010 07:51:18 GMT) Full text and rfc822 format available.

Added tag(s) fixed-upstream. Request was from bts-link-upstream@lists.alioth.debian.org to control@bugs.debian.org. (Mon, 25 Oct 2010 16:36:31 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#578547; Package libdata-alias-perl. (Tue, 26 Oct 2010 08:30:05 GMT) Full text and rfc822 format available.

Message #32 received at 578547@bugs.debian.org (full text, mbox):

From: pkg-perl-maintainers@lists.alioth.debian.org
To: 578547@bugs.debian.org, 578547-submitter@bugs.debian.org
Subject: Bug in libdata-alias-perl fixed in revision 64264
Date: Tue, 26 Oct 2010 08:26:39 +0000
tag 578547 + pending
thanks

Some bugs are closed in revision 64264
by Ansgar Burchardt (ansgar)

Commit message:

* New upstream release.
  + Works with perl 5.12. (Closes: #578547)
* Use source format 3.0 (quilt).
* debian/copyright: Formatting changes; add new copyright holder.
* Bump Standards-Version to 3.9.1.
* Add myself to Uploaders.




Added tag(s) pending. Request was from pkg-perl-maintainers@lists.alioth.debian.org to control@bugs.debian.org. (Tue, 26 Oct 2010 08:30:09 GMT) Full text and rfc822 format available.

Message sent on to Niko Tyni <ntyni@debian.org>:
Bug#578547. (Tue, 26 Oct 2010 08:30:11 GMT) Full text and rfc822 format available.

Reply sent to Ansgar Burchardt <ansgar@debian.org>:
You have taken responsibility. (Tue, 26 Oct 2010 08:51:04 GMT) Full text and rfc822 format available.

Notification sent to Niko Tyni <ntyni@debian.org>:
Bug acknowledged by developer. (Tue, 26 Oct 2010 08:51:04 GMT) Full text and rfc822 format available.

Message #42 received at 578547-close@bugs.debian.org (full text, mbox):

From: Ansgar Burchardt <ansgar@debian.org>
To: 578547-close@bugs.debian.org
Subject: Bug#578547: fixed in libdata-alias-perl 1.08-1
Date: Tue, 26 Oct 2010 08:47:43 +0000
Source: libdata-alias-perl
Source-Version: 1.08-1

We believe that the bug you reported is fixed in the latest version of
libdata-alias-perl, which is due to be installed in the Debian FTP archive:

libdata-alias-perl_1.08-1.debian.tar.gz
  to main/libd/libdata-alias-perl/libdata-alias-perl_1.08-1.debian.tar.gz
libdata-alias-perl_1.08-1.dsc
  to main/libd/libdata-alias-perl/libdata-alias-perl_1.08-1.dsc
libdata-alias-perl_1.08-1_amd64.deb
  to main/libd/libdata-alias-perl/libdata-alias-perl_1.08-1_amd64.deb
libdata-alias-perl_1.08.orig.tar.gz
  to main/libd/libdata-alias-perl/libdata-alias-perl_1.08.orig.tar.gz



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 578547@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Ansgar Burchardt <ansgar@debian.org> (supplier of updated libdata-alias-perl package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA512

Format: 1.8
Date: Tue, 26 Oct 2010 10:22:22 +0200
Source: libdata-alias-perl
Binary: libdata-alias-perl
Architecture: amd64 source
Version: 1.08-1
Distribution: unstable
Urgency: low
Maintainer: Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>
Changed-By: Ansgar Burchardt <ansgar@debian.org>
Closes: 578547
Description: 
 libdata-alias-perl - comprehensive set of aliasing operations
Changes: 
 libdata-alias-perl (1.08-1) unstable; urgency=low
 .
   [ Nathan Handler ]
   * debian/watch: Update to ignore development releases.
 .
   [ Ryan Niebur ]
   * Update ryan52's email address
 .
   [ Damyan Ivanov ]
   * add myself to Uploaders
   * debian/rules: DH7 tiny
   * debian/control: drop redundant version from perl dependencies
 .
   [ Ansgar Burchardt ]
   * New upstream release.
     + Works with perl 5.12. (Closes: #578547)
   * Use source format 3.0 (quilt).
   * debian/copyright: Formatting changes; add new copyright holder.
   * Bump Standards-Version to 3.9.1.
   * Add myself to Uploaders.
Checksums-Sha1: 
 3e391c0e4960926e05c86f8451da11b634a26536 2027 libdata-alias-perl_1.08-1.dsc
 24bafefeb1be1296e6493fb76891e38ee299cfa3 62816 libdata-alias-perl_1.08.orig.tar.gz
 e4cf7653a24b30e47cab61d7abcec2dc6d6798d9 2188 libdata-alias-perl_1.08-1.debian.tar.gz
 dbd3b9d7f189ef459ee93d76bb47ef5d341688a3 37396 libdata-alias-perl_1.08-1_amd64.deb
Checksums-Sha256: 
 3fd7ce5d721c8cc85864a6706f8b74df2e957034be11b9a2e69fb5fc4cae0c7f 2027 libdata-alias-perl_1.08-1.dsc
 0c93362057570339034eb8064ed0409edd8972219bf001f70adcbaced2997b48 62816 libdata-alias-perl_1.08.orig.tar.gz
 df4f5c8ac64c77fcd062ae288fd6d3cc6c2e4d1e7470453304f0fe019f9a3564 2188 libdata-alias-perl_1.08-1.debian.tar.gz
 1bcb13bc7db9125767b5d59bdc19904cbd14178452c0f1efde1b9ecfd784a203 37396 libdata-alias-perl_1.08-1_amd64.deb
Files: 
 2d57b8e7b067f9b8d32aa4fc189f48e0 2027 perl optional libdata-alias-perl_1.08-1.dsc
 b1d54d30610329d23c624d6aecaa50a6 62816 perl optional libdata-alias-perl_1.08.orig.tar.gz
 680ed79dcbf1085ebed89b01aa200569 2188 perl optional libdata-alias-perl_1.08-1.debian.tar.gz
 70260484b79355f480dcd9b2f8effcb0 37396 perl optional libdata-alias-perl_1.08-1_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iQIcBAEBCgAGBQJMxpBmAAoJEIATJTTdNH3IIIMP+wVqTZLAxlpj3fpqchWjMSu8
NKJ3+jz2uMQGk+joaxpQjA5/D8CDNlLHuTxQzd6qN5l/6lZu/is1Ml2hEb2OCu8b
1EsKHShO9w5plO1YqagDprHwbgIroVbVa4muHISO6pb8zg1LW2cW8O0OFOQS/pTg
AjSFQcM2Ww4p3SqyfGP1m2Bnru8qax+GzmtBPGxmjSm1crkA/Sn7VTII/AKccXvV
KF+znmLXcHnoaVbMotmT6Zo2E8qA3J0BRWi+WuhtNzZmMxLp462SsUHvwdyy4zed
eY6icAWEWOmDlt+MXoxksQCSFstX1qGrvsDmyiqgngld4ExHnD3qtem7tKI8bTxP
onnNvMHDvb/ur3l3VmKvFHaxsX6T5y3Pr9lwxfwpEObdlK3anXj5AD7CiWRpWGjD
hkuvU34/wdENM0ToHOGoqERrFrs5v9vi28yeRJ6swoO0anCqEhh6MtEHjWBUkOs6
TQcJCAILiTFzD5NCZXeHEUWOmX7AjciEUqdkWBe4Mt7KDNUGV7/wagAvZOJBJei+
4aGfZa1l/I4HH/DiEIrTDXxPvUxOeJYPcwftbwGvbAQj/tP7xCX3gdo3S4NtC8hZ
fC1FKuO+pplZzWD8iI4b9tsG3h92kEupoG2axNVgmwq0NTK7qhEc4gft+qzQhWBI
8uku7yQ11NCpgNa5rfEH
=kSX+
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 07 Mar 2011 09:01:59 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 15:16:54 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.